package wwc.messaging;

import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.ObjectInputStream;
import java.net.Socket;
import java.net.SocketException;
import java.net.ConnectException;

import java.util.Vector;

import salsa.language.Message;
import salsa.language.RunTime;

import salsa.naming.UAL;

public class OutgoingSocketHandler extends Thread {
	private int number;
	private Vector objects = new Vector();
	private Vector targets = new Vector();
/*static long count=0;

public static synchronized void incCount() {
          count++;
System.out.println("msg count:"+count);
        }
*/
	public OutgoingSocketHandler(int num) {
		number = num;
		start();
	}

	public void run() {
		while (true) {
			send();
		}
	}

	public synchronized void put(Object o, UAL target) {
		RunTime.sendingOutgoingObject();
		objects.addElement(o);
		targets.addElement(target);
		notify();
	}

	public synchronized void send() {
		if (objects.isEmpty()) {
			try {
				wait();      // The lock of Mailbox means it is empty.
                        } catch (InterruptedException ie){
				System.err.println("WWC Transport Service Error: ");
				System.err.println("\tError getting object to remote send");
				System.err.println("\t" + ie);
			}
		}

		Object o = objects.remove(0);
		UAL target = (UAL)targets.remove(0);

		try {
			Socket socket = new Socket(target.getHost(), target.getPort());
			ObjectOutputStream outputStream = new ObjectOutputStream(socket.getOutputStream());
//incCount();
			outputStream.writeObject(o);
			outputStream.flush();

			outputStream.close();
			socket.close();
		} catch (ConnectException e) {
			System.err.println("WWC Transport Service Error:");
			System.err.println("\tError sending: " + o);
			System.err.println("\tThrew Exception: " + e);
			System.err.println();
		} catch (SocketException e) {
			System.err.println("SOCKETEXCEPTION: " + e + ", OSH " + number + " to " + target);

			RunTime.sendingOutgoingObject();
			objects.insertElementAt(o,0);
			targets.insertElementAt(target,0);
		} catch (IOException e) {
			System.err.println("WWC Transport Service Error:");
			System.err.println("\tError sending: " + o);
			System.err.println("\tThrew Exception: " + e);
			System.err.println();
		} catch (Exception e) {
                        System.err.println("WWC Transport Service Unknown Error:");
                        System.err.println("\tError sending: " + o);
                        System.err.println("\tThrew Exception: " + e);
                        System.err.println();
                }

		RunTime.sentOutgoingObject();
	}
}
